"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionGrantRevocation = void 0;
var agent_1 = require("@web5/agent");
var agent_2 = require("@web5/agent");
var common_1 = require("@web5/common");
/**
 * The `PermissionGrantRevocation` class encapsulates a permissions protocol `grant/revocation` record, providing a more
 * developer-friendly interface for working with Decentralized Web Node (DWN) records.
 *
 * Methods are provided to manage the grant revocation's lifecycle, including writing to remote DWNs.
 *
 * @beta
 */
var PermissionGrantRevocation = /** @class */ (function () {
    function PermissionGrantRevocation(permissions, options) {
        this._permissions = permissions;
        this._connectedDid = options.connectedDid;
        // Store the message that represents the grant.
        this._message = options.message;
    }
    Object.defineProperty(PermissionGrantRevocation.prototype, "author", {
        /** The author of the underlying revocation message */
        get: function () {
            return (0, agent_1.getRecordAuthor)(this._message);
        },
        enumerable: false,
        configurable: true
    });
    /** parses the grant revocation given am agent, connectedDid and data encoded records write message  */
    PermissionGrantRevocation.parse = function (_a) {
        var connectedDid = _a.connectedDid, agent = _a.agent, message = _a.message;
        return __awaiter(this, void 0, void 0, function () {
            var permissions;
            return __generator(this, function (_b) {
                permissions = new agent_1.AgentPermissionsApi({ agent: agent });
                return [2 /*return*/, new PermissionGrantRevocation(permissions, { connectedDid: connectedDid, message: message })];
            });
        });
    };
    Object.defineProperty(PermissionGrantRevocation.prototype, "agent", {
        /** The agent to use for this instantiation of the grant revocation */
        get: function () {
            return this._permissions.agent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrantRevocation.prototype, "rawMessage", {
        /** The raw `RecordsWrite` DWN message with encoded data that was used to instantiate this grant revocation */
        get: function () {
            return this._message;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Send the current grant revocation to a remote DWN by specifying their DID
     * If no DID is specified, the target is assumed to be the owner (connectedDID).
     *
     * @param target - the optional DID to send the grant revocation to, if none is set it is sent to the connectedDid
     * @returns the status of the send grant revocation request
     *
     * @beta
     */
    PermissionGrantRevocation.prototype.send = function (target) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, sendRequestOptions, reply;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        target !== null && target !== void 0 ? target : (target = this._connectedDid);
                        _a = this._message, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        sendRequestOptions = {
                            messageType: agent_2.DwnInterface.RecordsWrite,
                            author: this._connectedDid,
                            target: target,
                            dataStream: dataStream,
                            rawMessage: rawMessage,
                        };
                        return [4 /*yield*/, this.agent.sendDwnRequest(sendRequestOptions)];
                    case 1:
                        reply = (_b.sent()).reply;
                        return [2 /*return*/, reply];
                }
            });
        });
    };
    /**
     * Stores the current grant revocation to the owner's DWN.
     *
     * @param importGrant - if true, the grant revocation will signed by the owner before storing it to the owner's DWN. Defaults to false.
     * @returns the status of the store request
     *
     * @beta
     */
    PermissionGrantRevocation.prototype.store = function (importRevocation) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, _b, reply, message;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.rawMessage, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        return [4 /*yield*/, this.agent.processDwnRequest({
                                author: this._connectedDid,
                                target: this._connectedDid,
                                messageType: agent_2.DwnInterface.RecordsWrite,
                                signAsOwner: importRevocation,
                                rawMessage: rawMessage,
                                dataStream: dataStream,
                            })];
                    case 1:
                        _b = _c.sent(), reply = _b.reply, message = _b.message;
                        this._message = __assign(__assign({}, message), { encodedData: encodedData });
                        return [2 /*return*/, { status: reply.status }];
                }
            });
        });
    };
    return PermissionGrantRevocation;
}());
exports.PermissionGrantRevocation = PermissionGrantRevocation;
//# sourceMappingURL=grant-revocation.js.map