"use strict";
/**
 * Making developing with Web5 components at least 5 times easier to work with.
 *
 * Web5 consists of the following components:
 * - Decentralized Identifiers
 * - Verifiable Credentials
 * - DWeb Node personal datastores
 *
 * The SDK sets out to gather the most oft used functionality from all three of
 * these pillar technologies to provide a simple library that is as close to
 * effortless as possible.
 *
 * The SDK is currently still under active development, but having entered the
 * Tech Preview phase there is now a drive to avoid unnecessary changes unless
 * backwards compatibility is provided. Additional functionality will be added
 * in the lead up to 1.0 final, and modifications will be made to address
 * issues and community feedback.
 *
 * [Link to GitHub Repo](https://github.com/TBD54566975/web5-js)
 *
 * @packageDocumentation
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.utils = void 0;
__exportStar(require("./did-api.js"), exports);
__exportStar(require("./dwn-api.js"), exports);
__exportStar(require("./grant-revocation.js"), exports);
__exportStar(require("./permission-grant.js"), exports);
__exportStar(require("./permission-request.js"), exports);
__exportStar(require("./protocol.js"), exports);
__exportStar(require("./record.js"), exports);
__exportStar(require("./vc-api.js"), exports);
__exportStar(require("./web5.js"), exports);
var utils = __importStar(require("./utils.js"));
exports.utils = utils;
//# sourceMappingURL=index.js.map