"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionGrant = void 0;
var common_1 = require("@web5/common");
var agent_1 = require("@web5/agent");
var grant_revocation_js_1 = require("./grant-revocation.js");
/**
 * The `PermissionGrant` class encapsulates a permissions protocol `grant` record, providing a more
 * developer-friendly interface for working with Decentralized Web Node (DWN) records.
 *
 * Methods are provided to revoke, check if isRevoked, and manage the grant's lifecycle, including writing to remote DWNs.
 *
 * @beta
 */
var PermissionGrant = /** @class */ (function () {
    function PermissionGrant(_a) {
        var api = _a.api, connectedDid = _a.connectedDid, message = _a.message, grant = _a.grant;
        this._permissions = api;
        // Store the connected DID for convenience.
        this._connectedDid = connectedDid;
        // Store the message that represents the grant.
        this._message = message;
        // Store the parsed grant object.
        this._grant = grant;
    }
    /** parses the grant given an agent, connectedDid and data encoded records write message  */
    PermissionGrant.parse = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var grant, api;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, agent_1.DwnPermissionGrant.parse(options.message)];
                    case 1:
                        grant = _a.sent();
                        api = new agent_1.AgentPermissionsApi({ agent: options.agent });
                        return [2 /*return*/, new PermissionGrant(__assign(__assign({}, options), { grant: grant, api: api }))];
                }
            });
        });
    };
    Object.defineProperty(PermissionGrant.prototype, "agent", {
        /** The agent to use for this instantiation of the grant */
        get: function () {
            return this._permissions.agent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "id", {
        /** The grant's ID, which is also the underlying record's ID */
        get: function () {
            return this._grant.id;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "grantor", {
        /** The DID which granted the permission  */
        get: function () {
            return this._grant.grantor;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "grantee", {
        /** The DID which the permission was granted to */
        get: function () {
            return this._grant.grantee;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "dateGranted", {
        /** The date the permission was granted */
        get: function () {
            return this._grant.dateGranted;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "description", {
        /** (optional) Description of the permission grant */
        get: function () {
            return this._grant.description;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "requestId", {
        /** (optional) The Id of the PermissionRequest if one was used */
        get: function () {
            return this._grant.requestId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "dateExpires", {
        /** The date on which the permission expires */
        get: function () {
            return this._grant.dateExpires;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "delegated", {
        /** Whether or not the permission grant can be used to impersonate the grantor */
        get: function () {
            return this._grant.delegated;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "scope", {
        /** The permission scope under which the grant is valid */
        get: function () {
            return this._grant.scope;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "conditions", {
        /** The conditions under which the grant is valid */
        get: function () {
            return this._grant.conditions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionGrant.prototype, "rawMessage", {
        /** The raw `RecordsWrite` DWN message with encoded data that was used to instantiate this grant */
        get: function () {
            return this._message;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Send the current grant to a remote DWN by specifying their DID
     * If no DID is specified, the target is assumed to be the owner (connectedDID).
     *
     * @param target - the optional DID to send the grant to, if none is set it is sent to the connectedDid
     * @returns the status of the send grant request
     *
     * @beta
     */
    PermissionGrant.prototype.send = function (target) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, sendRequestOptions, reply;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        target !== null && target !== void 0 ? target : (target = this._connectedDid);
                        _a = this._message, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        sendRequestOptions = {
                            messageType: agent_1.DwnInterface.RecordsWrite,
                            author: this._connectedDid,
                            target: target,
                            dataStream: dataStream,
                            rawMessage: rawMessage,
                        };
                        return [4 /*yield*/, this.agent.sendDwnRequest(sendRequestOptions)];
                    case 1:
                        reply = (_b.sent()).reply;
                        return [2 /*return*/, reply];
                }
            });
        });
    };
    /**
     * Stores the current grant to the owner's DWN.
     *
     * @param importGrant - if true, the grant will signed by the owner before storing it to the owner's DWN. Defaults to false.
     * @returns the status of the store request
     *
     * @beta
     */
    PermissionGrant.prototype.store = function (importGrant) {
        if (importGrant === void 0) { importGrant = false; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, _b, reply, message;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.rawMessage, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        return [4 /*yield*/, this.agent.processDwnRequest({
                                store: true,
                                author: this._connectedDid,
                                target: this._connectedDid,
                                messageType: agent_1.DwnInterface.RecordsWrite,
                                signAsOwner: importGrant,
                                rawMessage: rawMessage,
                                dataStream: dataStream,
                            })];
                    case 1:
                        _b = _c.sent(), reply = _b.reply, message = _b.message;
                        this._message = __assign(__assign({}, message), { encodedData: encodedData });
                        return [2 /*return*/, { status: reply.status }];
                }
            });
        });
    };
    /**
     * Signs the current grant as the owner and optionally stores it to the owner's DWN.
     * This is useful when importing a grant that was signed by someone else into your own DWN.
     *
     * @param store - if true, the grant will be stored to the owner's DWN after signing. Defaults to true.
     * @returns the status of the import request
     *
     * @beta
     */
    PermissionGrant.prototype.import = function (store) {
        if (store === void 0) { store = false; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, _b, reply, message;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.rawMessage, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        return [4 /*yield*/, this.agent.processDwnRequest({
                                store: store,
                                author: this._connectedDid,
                                target: this._connectedDid,
                                messageType: agent_1.DwnInterface.RecordsWrite,
                                signAsOwner: true,
                                rawMessage: rawMessage,
                                dataStream: dataStream,
                            })];
                    case 1:
                        _b = _c.sent(), reply = _b.reply, message = _b.message;
                        this._message = __assign(__assign({}, message), { encodedData: encodedData });
                        return [2 /*return*/, { status: reply.status }];
                }
            });
        });
    };
    /**
     * Revokes the grant and optionally stores the revocation to the owner's DWN.
     *
     * @param store - if true, the revocation will be stored to the owner's DWN. Defaults to true.
     * @returns {PermissionGrantRevocation} the grant revocation object
     *
     * @beta
     */
    PermissionGrant.prototype.revoke = function (store) {
        if (store === void 0) { store = true; }
        return __awaiter(this, void 0, void 0, function () {
            var revocation;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._permissions.createRevocation({
                            store: store,
                            author: this._connectedDid,
                            grant: this._grant,
                        })];
                    case 1:
                        revocation = _a.sent();
                        return [2 /*return*/, grant_revocation_js_1.PermissionGrantRevocation.parse({
                                connectedDid: this._connectedDid,
                                agent: this.agent,
                                message: revocation.message,
                            })];
                }
            });
        });
    };
    /**
     * Checks if the grant has been revoked.
     *
     * @param remote - if true, the check will be made against the remote DWN. Defaults to false.
     * @returns true if the grant has been revoked, false otherwise.
     * @throws if there is an error checking the revocation status.
     *
     * @beta
     */
    PermissionGrant.prototype.isRevoked = function (remote) {
        if (remote === void 0) { remote = false; }
        return this._permissions.isGrantRevoked({
            author: this._connectedDid,
            target: this.grantor,
            grantRecordId: this.id,
            remote: remote
        });
    };
    /**
     * @returns the JSON representation of the grant
     */
    PermissionGrant.prototype.toJSON = function () {
        return {
            id: this.id,
            grantor: this.grantor,
            grantee: this.grantee,
            dateGranted: this.dateGranted,
            description: this.description,
            requestId: this.requestId,
            dateExpires: this.dateExpires,
            delegated: this.delegated,
            scope: this.scope,
            conditions: this.conditions
        };
    };
    return PermissionGrant;
}());
exports.PermissionGrant = PermissionGrant;
//# sourceMappingURL=permission-grant.js.map