"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionRequest = void 0;
var agent_1 = require("@web5/agent");
var agent_2 = require("@web5/agent");
var common_1 = require("@web5/common");
var permission_grant_js_1 = require("./permission-grant.js");
/**
 * The `PermissionRequest` class encapsulates a permissions protocol `request` record, providing a more
 * developer-friendly interface for working with Decentralized Web Node (DWN) records.
 *
 * Methods are provided to grant the request and manage the request's lifecycle, including writing to remote DWNs.
 *
 * @beta
 */
var PermissionRequest = /** @class */ (function () {
    function PermissionRequest(_a) {
        var api = _a.api, connectedDid = _a.connectedDid, message = _a.message, request = _a.request;
        this._permissions = api;
        this._connectedDid = connectedDid;
        // Store the parsed request object.
        this._request = request;
        // Store the message that represents the grant.
        this._message = message;
    }
    /** parses the request given an agent, connectedDid and data encoded records write message  */
    PermissionRequest.parse = function (_a) {
        var connectedDid = _a.connectedDid, agent = _a.agent, message = _a.message;
        return __awaiter(this, void 0, void 0, function () {
            var request, api;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, agent_1.DwnPermissionRequest.parse(message)];
                    case 1:
                        request = _b.sent();
                        api = new agent_1.AgentPermissionsApi({ agent: agent });
                        return [2 /*return*/, new PermissionRequest({ api: api, connectedDid: connectedDid, message: message, request: request })];
                }
            });
        });
    };
    Object.defineProperty(PermissionRequest.prototype, "agent", {
        /** The agent to use for this instantiation of the request */
        get: function () {
            return this._permissions.agent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "id", {
        /** The request's ID, which is also the underlying record's ID  */
        get: function () {
            return this._request.id;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "requester", {
        /** The DID that is requesting a permission */
        get: function () {
            return this._request.requester;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "description", {
        /** (optional) Description of the permission request */
        get: function () {
            return this._request.description;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "delegated", {
        /** Whether or not the permission request can be used to impersonate the grantor */
        get: function () {
            return this._request.delegated;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "scope", {
        /** The permission scope under which the requested grant would be valid */
        get: function () {
            return this._request.scope;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "conditions", {
        /** The conditions under which the requested grant would be valid */
        get: function () {
            return this._request.conditions;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PermissionRequest.prototype, "rawMessage", {
        /** The `RecordsWrite` DWN message with encoded data that was used to instantiate this request */
        get: function () {
            return this._message;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Send the current permission request to a remote DWN by specifying their DID
     * If no DID is specified, the target is assumed to be the owner (connectedDID).
     *
     * @param target - the optional DID to send the permission request to, if none is set it is sent to the connectedDid
     * @returns the status of the send permission request
     *
     * @beta
     */
    PermissionRequest.prototype.send = function (target) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, sendRequestOptions, reply;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        target !== null && target !== void 0 ? target : (target = this._connectedDid);
                        _a = this._message, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        sendRequestOptions = {
                            messageType: agent_2.DwnInterface.RecordsWrite,
                            author: this._connectedDid,
                            target: target,
                            dataStream: dataStream,
                            rawMessage: rawMessage,
                        };
                        return [4 /*yield*/, this.agent.sendDwnRequest(sendRequestOptions)];
                    case 1:
                        reply = (_b.sent()).reply;
                        return [2 /*return*/, reply];
                }
            });
        });
    };
    /**
     * Stores the current permission request to the owner's DWN.
     *
     * @param importGrant - if true, the permission request will signed by the owner before storing it to the owner's DWN. Defaults to false.
     * @returns the status of the store request
     *
     * @beta
     */
    PermissionRequest.prototype.store = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encodedData, rawMessage, dataStream, _b, reply, message;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.rawMessage, encodedData = _a.encodedData, rawMessage = __rest(_a, ["encodedData"]);
                        dataStream = new Blob([common_1.Convert.base64Url(encodedData).toUint8Array()]);
                        return [4 /*yield*/, this.agent.processDwnRequest({
                                author: this._connectedDid,
                                target: this._connectedDid,
                                messageType: agent_2.DwnInterface.RecordsWrite,
                                rawMessage: rawMessage,
                                dataStream: dataStream,
                            })];
                    case 1:
                        _b = _c.sent(), reply = _b.reply, message = _b.message;
                        this._message = __assign(__assign({}, message), { encodedData: encodedData });
                        return [2 /*return*/, { status: reply.status }];
                }
            });
        });
    };
    /**
     * Grants the permission request to the requester.
     *
     * @param dateExpires - the date when the permission grant will expire.
     * @param store - if true, the permission grant will be stored in the owner's DWN. Defaults to true.
     * @returns {PermissionGrant} the granted permission.
     *
     * @beta
     */
    PermissionRequest.prototype.grant = function (dateExpires, store) {
        if (store === void 0) { store = true; }
        return __awaiter(this, void 0, void 0, function () {
            var message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._permissions.createGrant({
                            requestId: this.id,
                            grantedTo: this.requester,
                            scope: this.scope,
                            delegated: this.delegated,
                            author: this._connectedDid,
                            store: store,
                            dateExpires: dateExpires,
                        })];
                    case 1:
                        message = (_a.sent()).message;
                        return [2 /*return*/, permission_grant_js_1.PermissionGrant.parse({
                                connectedDid: this._connectedDid,
                                agent: this.agent,
                                message: message
                            })];
                }
            });
        });
    };
    /**
     * @returns the JSON representation of the permission request
     */
    PermissionRequest.prototype.toJSON = function () {
        return this._request;
    };
    return PermissionRequest;
}());
exports.PermissionRequest = PermissionRequest;
//# sourceMappingURL=permission-request.js.map